﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

*/
package 
{

	import flash.events.MouseEvent;
	import button.ButtonValider;
	import flash.net.FileReference;
	import org.bytearray.video.events.SlicedEvent;
	import org.bytearray.video.FLVSlice;
	import flash.media.Video;
	import flash.net.NetStream;
	import flash.net.NetConnection;
	import org.bytearray.video.FLVSlicer;

	import flash.display.Sprite;
	import flash.events.Event;
	
	import com.demonsters.debugger.MonsterDebugger;
	

	public class Main extends Sprite
	{
		[Embed( source="beyond-black-mesa-trailer.flv", mimeType="application/octet-stream" )]
		private var flvBytes:Class;
		
		private var oNetConnect : NetConnection;
		private var oNetStream : NetStream;
		private var video : Video;
	
		private var oBtnCut : ButtonValider;
		private var oBtnPlayPause : ButtonValider;
		private var oBtnDownload : ButtonValider;
		
		private var merged : FLVSlice;
		private var slicer : FLVSlicer;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}
		
		
		/**
		 * Démarrage de l'application.
		 * 
		 */
		protected function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
            MonsterDebugger.initialize(this);
            MonsterDebugger.trace(this, "Start Application");
            
         	var sFileVideo:String = "http://www.actionscript-facile.com/ressources/videos/beyond-black-mesa-trailer.flv";

         	// Récupération du film avec une variable FLASHVARS (path)
			var vars:Object = this.root.loaderInfo.parameters;
			
			oNetConnect = new NetConnection();
			oNetConnect.connect(null);
			
			oNetStream = new NetStream(oNetConnect);
			oNetStream.client = this;
			oNetStream.play(vars.path != null ? vars.path : sFileVideo);
			oNetStream.togglePause();// mise en pause de la vidéo
			
			video = new Video();
			video.x = 20;
			video.y = 20;
			video.attachNetStream(oNetStream);	
			
			// création de l'objet FLVSlice
			slicer = new FLVSlicer( new flvBytes() );	
			// écoute de l'évènement SlicedEvent.COMPLETE
			slicer.addEventListener( SlicedEvent.COMPLETE, onSliced );		
		}


		/**
		 * Evènement onMetaData.
		 * Diffusé par la vidéo.
		 * 
		 */
		public function onMetaData ( pEvt:Object ):void 
		{
			MonsterDebugger.trace(this, "onMetaDataw");
			
			// ajotu de la vidéo sur la scène
			if ( !contains ( video ) ) addChild(video);
			video.width = pEvt.width * 1.6;
			video.height = pEvt.height * 1.6;
			
			// création des boutons intéraction utilisateur
			oBtnPlayPause = new ButtonValider();
			oBtnPlayPause.getObject().label = "Play / Pause";
			oBtnPlayPause.getObject().x = 20;
			oBtnPlayPause.getObject().y = 330;
			oBtnPlayPause.getObject().addEventListener ( MouseEvent.CLICK, onPlayPause );
			addChild ( oBtnPlayPause );
			
			oBtnCut = new ButtonValider();
			oBtnCut.getObject().label = "Assembler la vidéo";
			oBtnCut.getObject().x = 20;
			oBtnCut.getObject().y = oBtnPlayPause.getObject().y + 30;
			oBtnCut.getObject().addEventListener ( MouseEvent.CLICK, onCutClick );
			addChild ( oBtnCut );
			
			oBtnDownload = new ButtonValider();
			oBtnDownload.getObject().label = "Télécharger la vidéo";
			oBtnDownload.getObject().x = oBtnPlayPause.getObject().x + 150;
			oBtnDownload.getObject().y = oBtnCut.getObject().y;
			oBtnDownload.getObject().addEventListener ( MouseEvent.CLICK, onDownloadClick );
			addChild ( oBtnDownload );
			
		}

		private function onPlayPause(event : MouseEvent) : void
		{
			oNetStream.togglePause();
		}
		
		
		
		/**
		 * L'assemblage de la vidéo est terminée.
		 * 
		 */
		private function onSliced(event : SlicedEvent) : void
		{
			MonsterDebugger.trace(this, "---> onSliced : "+"Sliced video : ");// + int(event.stream.length / 1024) + " kb");
		}
		
		
		private function onDownloadClick ( pEvt:MouseEvent ):void 
		{
			MonsterDebugger.trace(this, "onDownloadClick");
			if(merged != null)
			{
				var file:FileReference = new FileReference();
				// création du fichier vidéo de sortie
				file.save(merged.stream, "extrait.flv");
				MonsterDebugger.trace(this, "FileReference");
			}
		}
		
		private function onCutClick ( pEvt:MouseEvent ):void 
		{
			oNetStream.seek(1000);
			MonsterDebugger.trace(this, "onCutClick");
			
			/* création d'un extrait en ajoutant 2 morceaux de la vidéo */
			
			// création de l'extrait - début en ms - fin en ms			
			var fisrtVideo:FLVSlice = slicer.slice(4000, 13000);
			var secondVideo:FLVSlice = slicer.slice(20000, 30000);
			
			// création du vecteur FLVSlice
			var slices:Vector.<FLVSlice> = new Vector.<FLVSlice>();
			
			// ajout des extraits
			slices.push ( fisrtVideo );
			slices.push ( secondVideo );
			
			// assemblage des extrait dans un fichier flv
			merged = slicer.merge( slices );
		}
	}
}
